## hackrf 2026.01.3

=== docs/requirements.txt ===
sphinx==7.2.6
sphinx_rtd_theme==2.0.0
readthedocs-sphinx-search==0.3.2
jinja2==3.1.6

=== firmware/CMakeLists.txt ===
# Copyright 2012 Jared Boone <jared@sharebrained.com>
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

# Top directory CMake project for HackRF firmware

cmake_minimum_required(VERSION 3.10.0)
set(CMAKE_TOOLCHAIN_FILE toolchain-arm-cortex-m.cmake)

project (hackrf_firmware_all C)

add_subdirectory(blinky)
add_subdirectory(hackrf_usb)

=== host/CMakeLists.txt ===
# top dir cmake project for libhackrf + tools

cmake_minimum_required(VERSION 3.10.0)
project(HackRF C)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_C_FLAGS
    "$ENV{CFLAGS}"
    CACHE STRING "C Flags")

add_subdirectory(libhackrf)
add_subdirectory(hackrf-tools)

# ##############################################################################
# Create uninstall target
# ##############################################################################

configure_file(${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake @ONLY)

add_custom_target(
  uninstall
  COMMENT "Provide uninstall target"
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== firmware/blinky/CMakeLists.txt ===
# Copyright 2012 Michael Ossmann <mike@ossmann.com>
# Copyright 2012 Jared Boone <jared@sharebrained.com>
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

cmake_minimum_required(VERSION 3.10.0)
set(CMAKE_TOOLCHAIN_FILE ../toolchain-arm-cortex-m.cmake)

project(blinky C)

include(../hackrf-common.cmake)

set(SRC_M4
	blinky.c
)

DeclareTargets()

=== firmware/fpga/requirements.txt ===
amaranth==v0.5.8
amaranth-boards @ git+https://github.com/amaranth-lang/amaranth-boards.git@23c66d6
lz4
numpy

=== firmware/hackrf_usb/CMakeLists.txt ===
# Copyright 2012 Jared Boone <jared@sharebrained.com>
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

cmake_minimum_required(VERSION 3.10.0)
set(CMAKE_TOOLCHAIN_FILE ../toolchain-arm-cortex-m.cmake)

project(hackrf_usb C)

include(../hackrf-common.cmake)

add_custom_command(
	OUTPUT ${PATH_HACKRF_CPLD_DATA_C}
	COMMAND ${PATH_CPLD_BITSTREAM_TOOL} --xsvf ${PATH_HACKRF_CPLD_XSVF} --hackrf-data ${PATH_HACKRF_CPLD_DATA_C}
	DEPENDS ${PATH_CPLD_BITSTREAM_TOOL} ${PATH_HACKRF_CPLD_XSVF}
)

add_custom_command(
	OUTPUT ${PATH_PRALINE_FPGA_OBJ}
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMAND ${CMAKE_COMMAND} -E copy ${PATH_PRALINE_FPGA_BIN} "fpga.bin"
	COMMAND ${CMAKE_OBJCOPY} 
		-I binary
		-O elf32-littlearm
		--rename-section .data=.rom_only
		"fpga.bin" ${PATH_PRALINE_FPGA_OBJ}
	DEPENDS ${PATH_PRALINE_FPGA_BIN}
)

set(SRC_M4
	hackrf_usb.c
	"${PATH_HACKRF_FIRMWARE_COMMON}/tuning.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/streaming.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/usb.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/usb_request.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/usb_standard_request.c"
	usb_descriptor.c
	usb_device.c
	usb_endpoint.c
	usb_api_board_info.c
	usb_api_m0_state.c
	usb_api_register.c
	usb_api_spiflash.c
	usb_api_transceiver.c
	usb_api_operacake.c
	usb_api_sweep.c
	usb_api_selftest.c
	usb_api_ui.c
	usb_api_adc.c
	"${PATH_HACKRF_FIRMWARE_COMMON}/usb_queue.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/fault_handler.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/cpld_jtag.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/crc.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/rom_iap.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/operacake.c"
	"${PATH_HACKRF_FIRMWARE_COMMON}/operacake_sctimer.c"
)

set(SRC_M0 sgpio_m0.s)

if(BOARD STREQUAL "PRALINE")
	SET(SRC_M4
		${SRC_M4}
		"${PATH_HACKRF_FIRMWARE_COMMON}/lz4_blk.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/fpga_image.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/fpga_selftest.c"
		usb_api_praline.c
	)
	SET(OBJ_M4
		${PATH_PRALINE_FPGA_OBJ}
	)
else()
	SET(SRC_M4
		${SRC_M4}
		usb_api_cpld.c
		"${PATH_HACKRF_FIRMWARE_COMMON}/cpld_xc2c.c"
		"${PATH_HACKRF_CPLD_DATA_C}"
		"${PATH_HACKRF_FIRMWARE_COMMON}/xapp058/lenval.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/xapp058/micro.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/xapp058/ports.c"
	)
endif()

if(BOARD STREQUAL "HACKRF_ONE" OR BOARD STREQUAL "PRALINE")
	SET(SRC_M4
		${SRC_M4}
		"${PATH_HACKRF_FIRMWARE_COMMON}/portapack.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/ui_portapack.c"
	)
endif()

if(BOARD STREQUAL "RAD1O")
	SET(SRC_M4
		${SRC_M4}
		"${PATH_HACKRF_FIRMWARE_COMMON}/rad1o/display.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/rad1o/print.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/rad1o/render.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/rad1o/decoder.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/rad1o/smallfonts.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/rad1o/draw.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/rad1o/ubuntu18.c"
		"${PATH_HACKRF_FIRMWARE_COMMON}/ui_rad1o.c"
	)
endif()

DeclareTargets()

=== host/hackrf-tools/CMakeLists.txt ===
# Copyright 2012 Jared Boone
# Copyright 2013 Benjamin Vernoux
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; see the file COPYING.  If not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Boston, MA 02110-1301, USA.

cmake_minimum_required(VERSION 3.10.0)
project(hackrf-tools LANGUAGES C)
include(GNUInstallDirs)

include(${PROJECT_SOURCE_DIR}/../cmake/set_release.cmake)
add_definitions(-DTOOL_RELEASE="${RELEASE}")
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/../cmake/modules)

if(MSVC)
  include_directories(getopt)
  add_definitions(/D _CRT_SECURE_NO_WARNINGS)
else()
  add_definitions(-Wall)
endif()

if(NOT libhackrf_SOURCE_DIR)
  if(LIBHACKRF_INCLUDE_DIR
     AND LIBHACKRF_LIBRARIES
     AND NOT TARGET HackRF::hackrf)
    add_library(HackRF::hackrf INTERFACE IMPORTED)
    set_target_properties(
      HackRF::hackrf
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${LIBHACKRF_INCLUDE_DIR}"
                 INTERFACE_LINK_LIBRARIES "${LIBHACKRF_LIBRARIES}")
  else()
    find_package(HackRF REQUIRED)
  endif()
endif()

add_subdirectory(src)

########################################################################
# Create uninstall target
########################################################################

if(NOT HackRF_SOURCE_DIR)
  configure_file(${PROJECT_SOURCE_DIR}/../cmake/cmake_uninstall.cmake.in
                 ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake @ONLY)

  add_custom_target(
    uninstall
    COMMENT "Provide hackrf-tools uninstall target"
    COMMAND ${CMAKE_COMMAND} -P
            ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== host/libhackrf/CMakeLists.txt ===
# Copyright 2012 Jared Boone
# Copyright 2013 Benjamin Vernoux
#
# This file is part of HackRF.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; see the file COPYING.  If not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Boston, MA 02110-1301, USA.

cmake_minimum_required(VERSION 3.10.0)
project(
  libhackrf
  LANGUAGES C
  VERSION 0.9.2)
include(GNUInstallDirs)
include(${PROJECT_SOURCE_DIR}/../cmake/set_release.cmake)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/../cmake/modules)

if(MSVC)
  set(THREADS_USE_PTHREADS_WIN32 true)
else()
  include(TestBigEndian)
  test_big_endian(BIGENDIAN)
  if(${BIGENDIAN})
    add_definitions(-DHACKRF_BIG_ENDIAN)
  endif(${BIGENDIAN})
endif()

find_package(LIBUSB REQUIRED)
find_package(Threads REQUIRED)
find_package(PThreads4W QUIET)

add_subdirectory(src)

# ##############################################################################
# Create Cmake Config-file package interface
# ##############################################################################
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/HackRF/HackRFConfigVersion.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)

export(
  EXPORT HackRFTargets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/HackRF/HackRFTargets.cmake"
  NAMESPACE HackRF::)
configure_file(HackRFConfig.cmake
               "${CMAKE_CURRENT_BINARY_DIR}/HackRF/HackRFConfig.cmake" COPYONLY)

set(CONFIG_PACKAGE_LOCATION ${CMAKE_INSTALL_LIBDIR}/cmake/HackRF)
install(
  EXPORT HackRFTargets
  FILE HackRFTargets.cmake
  NAMESPACE HackRF::
  DESTINATION ${CONFIG_PACKAGE_LOCATION})
install(
  FILES HackRFConfig.cmake ../cmake/modules/FindLIBUSB.cmake
        "${CMAKE_CURRENT_BINARY_DIR}/HackRF/HackRFConfigVersion.cmake"
  DESTINATION ${CONFIG_PACKAGE_LOCATION}
  COMPONENT Devel)

# ##############################################################################
# Create Pkg Config File
# ##############################################################################
foreach(inc ${LIBUSB_INCLUDE_DIR})
  list(APPEND HACKRF_PC_CFLAGS "-I${inc}")
endforeach(inc)

# use space-separation format for the pc file
string(REPLACE ";" " " HACKRF_PC_CFLAGS "${HACKRF_PC_CFLAGS}")
string(REPLACE ";" " " HACKRF_PC_LIBS "${HACKRF_PC_LIBS}")

# unset these vars to avoid hard-coded paths to cross environment
if(CMAKE_CROSSCOMPILING)
  unset(HACKRF_PC_CFLAGS)
  unset(HACKRF_PC_LIBS)
endif(CMAKE_CROSSCOMPILING)

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix \${prefix})
set(libdir \${exec_prefix}/lib${LIB_SUFFIX})
set(includedir \${prefix}/include)
set(libpkgdata lib${LIB_SUFFIX})

if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  set(libpkgdata "libdata")
endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libhackrf.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/libhackrf.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libhackrf.pc
        DESTINATION ${libpkgdata}/pkgconfig)

# ##############################################################################
# Handle udev rules file
# ##############################################################################

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(SYSTEM_IS_LINUX TRUE)
  set(UDEV_OPTION_DEFAULT ON)
else()
  set(SYSTEM_IS_LINUX FALSE)
  set(UDEV_OPTION_DEFAULT OFF)
endif()

option(INSTALL_UDEV_RULES "Install udev rules for the HackRF"
       ${UDEV_OPTION_DEFAULT})

set(UDEV_RULES_PATH
    "/etc/udev/rules.d"
    CACHE STRING "Target directory for udev rule installation.
 Ensure you have permissions to write to this directory.")

if(SYSTEM_IS_LINUX)
  if(INSTALL_UDEV_RULES)
    if(NOT DEFINED UDEV_RULES_GROUP)
      foreach(group usb plugdev)
        execute_process(
          COMMAND "getent" group "${group}"
          RESULT_VARIABLE _GETENT_RESULT
          OUTPUT_QUIET ERROR_QUIET)
        if(NOT _GETENT_RESULT)
          message(STATUS "Setting udev rule group to - ${group}")
          set(UDEV_RULES_GROUP ${group})
          break()
        endif(NOT _GETENT_RESULT)
      endforeach(group)
    endif(NOT DEFINED UDEV_RULES_GROUP)
    if(DEFINED UDEV_RULES_GROUP)
      set(HACKRF_GROUP
          "${UDEV_RULES_GROUP}"
          CACHE STRING "Group to associate HackRF devices with in udev rules")
      configure_file(${CMAKE_CURRENT_SOURCE_DIR}/53-hackrf.rules.in
                     ${CMAKE_CURRENT_BINARY_DIR}/53-hackrf.rules @ONLY)
      message(
        STATUS "HackRF udev rules will be installed to '${UDEV_RULES_PATH}'")
      install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/53-hackrf.rules
        DESTINATION ${UDEV_RULES_PATH}
        COMPONENT "udev_rules")
    else(UDEV_RULES_GROUP)
      message(
        STATUS
          "HackRF udev rules will not be installed because no group was found")
      message(STATUS "A group can be specified with -DUDEV_RULES_GROUP=<group>")
    endif(DEFINED UDEV_RULES_GROUP)
  else(INSTALL_UDEV_RULES)
    message(
      STATUS
        "HackRF udev rules will not be installed because INSTALL_UDEV_RULES=OFF"
    )
  endif(INSTALL_UDEV_RULES)
else(SYSTEM_IS_LINUX)
  if(INSTALL_UDEV_RULES)
    message(STATUS "udev rules not supported on this platform.")
    message(STATUS "Hide this message via -DINSTALL_UDEV_RULES=Off")
  endif(INSTALL_UDEV_RULES)
endif(SYSTEM_IS_LINUX)

# ##############################################################################
# Create uninstall target
# ##############################################################################
if(NOT HackRF_SOURCE_DIR)
  configure_file(${PROJECT_SOURCE_DIR}/../cmake/cmake_uninstall.cmake.in
                 ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake @ONLY)

  add_custom_target(
    uninstall
    COMMENT "Provide libhackrf uninstall target"
    COMMAND ${CMAKE_COMMAND} -P
            ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== host/libhackrf/src/CMakeLists.txt ===
# Copyright (c) 2012, Jared Boone <jared@sharebrained.com>
# Copyright (c) 2013, Benjamin Vernoux <titanmkd@gmail.com>
# Copyright (c) 2013, Michael Ossmann <mike@ossmann.com>
# Copyright (c) 2025, A. Maitland Bottoms <bottoms@debian.org>
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer. Redistributions in binary
# form must reproduce the above copyright notice, this list of conditions and
# the following disclaimer in the documentation and/or other materials provided
# with the distribution. Neither the name of Great Scott Gadgets nor the names
# of its contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

option(ENABLE_STATIC_LIB "Build and Install libhackrf.a static library" ON)
option(ENABLE_SHARED_LIB "Build and Install libhackrf.so shared library" ON)
option(
  DISABLE_USB_DEVICE_DISCOVERY
  "Prevent libusb from trying to enumerate devices. Useful on non-root android"
  ANDROID)

# For cygwin just force UNIX OFF and WIN32 ON
if(${CYGWIN})
  set(UNIX OFF)
  set(WIN32 ON)
endif(${CYGWIN})

# Settings common for shared and static libraries
function(libhackrf_common_settings libtarget)
  target_compile_features(${libtarget} PRIVATE c_std_90)
  set_target_properties(hackrf PROPERTIES CLEAN_DIRECT_OUTPUT 1)

  target_compile_definitions(
    ${libtarget} PRIVATE -DLIBRARY_VERSION="${PROJECT_VERSION}"
                         -DLIBRARY_RELEASE="${RELEASE}")
  if(DISABLE_USB_DEVICE_DISCOVERY)
    target_compile_definitions(${libtarget}
                               PRIVATE -DDISABLE_USB_DEVICE_DISCOVERY)
  endif()

  target_include_directories(
    ${libtarget}
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/libhackrf>)

  target_link_libraries(${libtarget} PRIVATE LIBUSB::LIBUSB)
  if(TARGET PThreads4W::PThreads4W)
    target_link_libraries(${libtarget} PRIVATE PThreads4W::PThreads4W)
  else()
    target_link_libraries(${libtarget} PRIVATE Threads::Threads)
  endif()

  if(${UNIX})
    install(
      TARGETS ${libtarget}
      EXPORT HackRFTargets
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT sharedlibs
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
  endif(${UNIX})

  if(${WIN32})
    install(
      TARGETS ${libtarget}
      EXPORT HackRFTargets
      DESTINATION bin
      COMPONENT sharedlibs)
  endif(${WIN32})
endfunction()

# Dynamic library
if(ENABLE_SHARED_LIB)
  add_library(hackrf SHARED hackrf.c)
  set_target_properties(hackrf PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR})
  libhackrf_common_settings(hackrf)
  add_library(HackRF::hackrf ALIAS hackrf)
endif()

# Static library
if(ENABLE_STATIC_LIB)
  add_library(hackrf_static STATIC hackrf.c)
  if(MSVC)
    set_target_properties(hackrf_static PROPERTIES OUTPUT_NAME "hackrf_static")
  else()
    set_target_properties(hackrf_static PROPERTIES OUTPUT_NAME "hackrf")
  endif()
  libhackrf_common_settings(hackrf_static)
endif()

if(${WIN32})
  install(
    DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/$<CONFIGURATION>/"
    DESTINATION bin
    FILES_MATCHING
    PATTERN "libusb*.dll"
    PATTERN "pthread*.dll")
endif(${WIN32})

install(
  FILES hackrf.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
  COMPONENT headers)

=== debian/changelog ===
hackrf (2026.01.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #1127759)
  * Use Picolibc!
  * Update Standards-Version (no changes)
  * update watch file
  * update man pages

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 16 Feb 2026 15:59:43 -0500

=== debian/control ===
Source: hackrf
Section: libs
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
	       gcc-arm-none-eabi,
               libfftw3-dev,
               libusb-1.0-0-dev,
	       picolibc-arm-none-eabi,
               pkgconf
Build-Depends-Indep: dfu-util,
                     latexmk,
                     python3-sphinx,
                     python3-sphinx-rtd-theme,
                     python3-yaml,
                     tex-gyre,
                     texlive-latex-extra
Standards-Version: 4.7.3
Rules-Requires-Root: no
Homepage: http://greatscottgadgets.com/hackrf/
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-hackrf
Vcs-Git: https://salsa.debian.org/bottoms/pkg-hackrf.git

Package: hackrf-doc
Section: doc
Architecture: all
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         sphinx,
         ${misc:Depends}
Description: Software defined radio peripheral - documentation
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains generated documentation.

Package: libhackrf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libhackrf0 (= ${binary:Version}), ${misc:Depends}
Description: Software defined radio peripheral - development
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains development files.

Package: libhackrf0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Software defined radio peripheral - runtime library
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains the shared library.

Package: hackrf
Section: comm
Architecture: any
Depends: libhackrf0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Software defined radio peripheral - utilities
 HackRF is an open source Software Defined Radio that can receive
 and transmit between 30 MHz and 6 GHz. HackRF has a 20 MHz bandwidth.
 It is a High Speed USB device powered by the USB bus.
 .
 This package contains a set of command line utilities:
  * hackrf_clock: HackRF clock configuration utility
  * hackrf_cpldjtag: program CLPD
  * hackrf_debug: chip register read/write/config tool
  * hackrf_info: probe device and show configuration
  * hackrf_operacake: control of operacake board via hackrf
  * hackrf_spiflash: read and write flash data from file.
  * hackrf_sweep: control frequency sweep of hackrf
  * hackrf_transfer: file based transmit and receive sdr

Package: hackrf-firmware
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hackrf
Suggests: dfu-util
Description: Firmware for HackRF devices
 The HackRF hardware needs some firmware to run. The firmware is built with
 arm-none-eabi-gcc. This package contains a number of firmware images that
 may be programmed into the HackRF hardware using the 'hackrf_spiflash -w'
 command or dfu-util.
 .
 The following hardware is supported:
  * hackrf_jawbreaker
  * hackrf_one
  * hackrf_rad1o
 .
 The firmware images are installed in /usr/share/hackrf/firmware/

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS += hardening=+all

%:
	dh $@ --sourcedirectory=host --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=host --builddirectory=build -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)
	- cp -p build/libhackrf/53-hackrf.rules debian/libhackrf0.udev

override_dh_auto_build-indep: build-arch
	cd docs && make html
	cd docs && make latex
	cd docs && make latexpdf
	cd docs/build/html/_static && rm jquery.js
	cd docs/build/html/_static && ln -s /usr/share/javascript/jquery/jquery.js jquery.js
	cd docs/build/html/_static && rm _sphinx_javascript_frameworks_compat.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/_sphinx_javascript_frameworks_compat.js _sphinx_javascript_frameworks_compat.js
	cd docs/build/html/_static && rm doctools.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/doctools.js doctools.js
	cd docs/build/html/_static && rm language_data.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/language_data.js_t language_data.js
	cd docs/build/html/_static && rm searchtools.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/searchtools.js searchtools.js
	cd docs/build/html/_static && rm sphinx_highlight.js
	cd docs/build/html/_static && ln -s /usr/share/sphinx/themes/basic/static/sphinx_highlight.js sphinx_highlight.js
	rm -rf docs/build/html/_static/fonts
	cp -p -r firmware-libopencm3/* firmware/libopencm3/
	cd firmware && CFLAGS=-Wall CXXFLAGS=-Wall cmake -DCMAKE_TRY_COMPILE_TARGET_TYPE="STATIC_LIBRARY" -DCMAKE_VERBOSE_MAKEFILE=ON -DBOARD=HACKRF_ONE -B build_hackrf
	cd firmware && cmake --build build_hackrf
	cd firmware && CFLAGS=-Wall CXXFLAGS=-Wall cmake -DCMAKE_TRY_COMPILE_TARGET_TYPE="STATIC_LIBRARY" -DCMAKE_VERBOSE_MAKEFILE=ON -DBOARD=JAWBREAKER -B build_jawbreaker
	cd firmware && cmake --build build_jawbreaker
	cd firmware && CFLAGS=-Wall CXXFLAGS=-Wall cmake -DCMAKE_TRY_COMPILE_TARGET_TYPE="STATIC_LIBRARY" -DCMAKE_VERBOSE_MAKEFILE=ON -DBOARD=RAD1O -B build_rad1o
	cd firmware && cmake --build build_rad1o
	cp -p firmware/build_jawbreaker/hackrf_usb/hackrf_usb.bin firmware/hackrf_jawbreaker_usb.bin
	cp -p firmware/build_hackrf/hackrf_usb/hackrf_usb.bin firmware/hackrf_one_usb.bin
	cp -p firmware/build_rad1o/hackrf_usb/hackrf_usb.bin firmware/hackrf_rad1o_usb.bin
	chmod -x firmware/hackrf_jawbreaker_usb.bin
	chmod -x firmware/hackrf_one_usb.bin
	chmod -x firmware/hackrf_rad1o_usb.bin
	cp -p firmware/build_jawbreaker/hackrf_usb/hackrf_usb.dfu firmware/hackrf_jawbreaker_usb.dfu
	cp -p firmware/build_hackrf/hackrf_usb/hackrf_usb.dfu firmware/hackrf_one_usb.dfu
	cp -p firmware/build_rad1o/hackrf_usb/hackrf_usb.dfu firmware/hackrf_rad1o_usb.dfu

override_dh_installdocs-indep:
	dh_installdocs --indep

override_dh_installudev:
	dh_installudev
	# This should be harmless for indep builds or after dh_installudev changes the install path.
	set -e; if test -d debian/libhackrf0/lib/udev/rules.d; then mv debian/libhackrf0/lib/udev debian/libhackrf0/usr/lib; fi
	set -e; if test -d debian/libhackrf0/lib; then rmdir debian/libhackrf0/lib; fi

=== debian/watch ===
Version: 5

Source: https://github.com/greatscottgadgets//hackrf/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
Update-Script: uupdate

Component: firmware-libopencm3
Source: https://github.com/mossmann/libopencm3.git
Matching-Pattern: HEAD
Mode: git
Pgpmode: none
Version-Schema: ignore
